using System;

namespace AutomataPattern
{
	public class Automata
	{
		private TransitionContainer _transitionContainer = new TransitionContainer();
		private object _o;
		protected State _state;

		public object Args
		{
			get { return _o; }
		}

		public State State
		{
			get { return _state; }
			set { _state = value; }
		}

		public TransitionContainer Transitions
		{
			get { return _transitionContainer; }
		}

		public Automata( State initialState, object o )
		{			
			_o = o;
			_state = initialState;
		}

		public void Execute( int e )
		{
			_state.Execute( e ); 
			_state = _transitionContainer.GetNextState( _state, e );
			_state.Log();
		}
	}
}
